# -*- ruby -*-
# $Id: circle.rb,v 1.1 2001/11/17 12:36:53 ttate Exp $

module Fltk
class Canvas
  class Circle < CanvasItem
    def initialize(canvas, x, y, r = nil, lstyle = nil, lwidth = nil,
		   color1 = nil, color2 = nil, fill = nil)
      super(canvas, lstyle, lwidth, color1, color2, fill)
      r ||= 2
      fill ||= false
      @x = x
      @y = y
      @r = r
    end

    def under_mouse?(x, y)
      if( (@x - @r - @range <= x) && (x <= @x + @r + @range ) &&
	  (@y - @r - @range <= y) && (y <= @y + @r + @range ) )
	return true
      else
	return false
      end
    end

    def draw
      set_style{
	gx,gy,gr = grid(@x,@y,@r)
	if( @fill )
	  @canvas.pie(gx-gr,gy-gr,gr*2,gr*2,0,360)
	else
	  @canvas.arc(gx-gr,gy-gr,gr*2,gr*2,0,360)
	end
      }
    end

    def move(x1, y1, x2, y2)
      dx = x2 - x1
      dy = y2 - y1
      d = (@x - x1)**2 + (@y - y1)**2 
      if( d > @r ** 2 )
	if( (x1 - @x)**2 + (y1 - @y)**2 < (x2 - @x)**2 + (y2 - @y)**2 )
	  @r += Math.sqrt(dx ** 2 + dy ** 2).to_i
	else
	  @r -= Math.sqrt(dx ** 2 + dy ** 2).to_i
	  if( @r < @range )
	    @r = @range
	  end
	end
      else
	@x += dx
	@y += dy
      end
    end
  end
end
end
