# -*- ruby -*-
# $Id: ellipse.rb,v 1.1 2001/11/17 12:36:53 ttate Exp $

require 'fltk/canvas/line'

module Fltk
class Canvas
  class Ellipse < CanvasItem
    def initialize(canvas, x, y, width, height, lstyle = nil, lwidth = nil,
		   color1 = nil, color2 = nil, fill = nil)
      super(canvas, lstyle, lwidth, color1, color2, fill)
      @x = x
      @y = y
      @w = width
      @h = height
    end

    def move(x1, y1, x2, y2)
      dx = x2 - x1
      dy = y2 - y1
      cx = @x + @w / 2
      cy = @y + @h / 2
      bx = @x + @w
      by = @y + @h
      if( (cx - x1)**2 + (@y - y1)**2 <= @range**2 )
	@y += dy
	@h -= dy
      elsif( (cx - x1)**2 + (by - y1)**2 <= @range**2 )
	@h += dy
      elsif( (@x - x1)**2 + (cy - y1)**2 <= @range**2 )
	@x += dx
	@w -= dx
      elsif( (bx - x1)**2 + (cy - y1)**2 <= @range**2 )
	@w += dx
      else
	@x += dx
	@y += dy
      end
      if( @w < 0 )
	@x += @w
	@w = - @w
      end
      if( @h < 0 )
	@y += @h
	@h = - @h
      end
    end

    def under_mouse?(x, y)
      if( @x - @range <= x && x <= (@x + @w + @range) &&
	  @y - @range <= y && y <= (@y + @h + @range) )
	return true
      else
	return false
      end
    end

    def draw
      set_style{
	gx,gy,gw,gh = grid(@x,@y,@w,@h)
	if( @fill )
	  @canvas.pie(gx,gy,gw,gh,0,360)
	else
	  @canvas.arc(gx,gy,gw,gh,0,360)
	end
      }
    end
  end
end
end
