# -*- ruby -*-
# $Id: label.rb,v 1.1 2001/11/17 12:36:53 ttate Exp $

module Fltk
class Canvas
  class Label < CanvasItem
    def initialize(canvas, x, y, text = nil, font = nil, size = nil, lstyle = nil, lwidth = nil,
		   color1 = nil, color2 = nil, fill = nil)
      super(canvas, lstyle, lwidth, color1, color2, fill)
      @x = x
      @y = y
      @text = text || ""
      @font = font || Fltk::HELVETICA
      @size = size || 12
    end

    def move(x1, y1, x2, y2)
      dx = x2 - x1
      dy = y2 - y1
      @x += dx
      @y += dy
    end

    def under_mouse?(x, y)
      width = Fltk.width(@text)
      if( (@x - @range <= x) && (x <= @x + width + @range) &&
	  (@y - @size - @range <= y) && (y <= @y + @size) )
	return true
      else
	return false
      end
    end

    def draw
      set_style{
	Fltk.font(@font,@size)
	gx,gy = grid(@x,@y)
	@canvas.text_draw(@text,gx,gy)
      }
    end
  end
end
end
