# -*- ruby -*-
# $Id: rect.rb,v 1.1 2001/11/17 12:36:53 ttate Exp $

require 'fltk/canvas/line'

module Fltk
class Canvas
  class Rect < CanvasItem
    def initialize(canvas, x, y, width, height, lstyle = nil, lwidth = nil,
		   color1 = nil, color2 = nil, fill = nil)
      super(canvas, lstyle, lwidth, color1, color2, fill)
      @x = x
      @y = y
      @w = width
      @h = height
    end

    def move(x1, y1, x2, y2)
      dx = x2 - x1
      dy = y2 - y1
      if( (@x - x1)**2 + (@y - y1)**2 < (@range * 2) ** 2)
	@x += dx
	@y += dy
	@w -= dx
	@h -= dy
      elsif( (@x + @w - x1)**2 + (@y - y1)**2 < (@range * 2) ** 2)
	@y += dy
	@w += dx
	@h -= dy
      elsif( (@x + @w - x1)**2 + (@y + @h - y1)**2 < (@range * 2) ** 2 )
	@w += dx
	@h += dy
      elsif( (@x - x1)**2 + (@y + @h - y1)**2 < (@range * 2) ** 2 )
	@x += dx
	@h += dy
	@w -= dx
      else
	@x += dx
	@y += dy
      end
      if( @w < 0 )
	@x += @w
	@w = - @w
      end
      if( @h < 0 )
	@y += @h
	@h = - @h
      end
    end

    def under_mouse?(x, y)
      if( @x - @range <= x && x <= (@x + @w + @range) &&
	  @y - @range <= y && y <= (@y + @h + @range) )
	return true
      else
	return false
      end
    end

    def draw
      set_style{
	if( @fill )
	  @canvas.rectf(*grid(@x,@y,@w,@h))
	else
	  @canvas.rect(*grid(@x,@y,@w,@h))
	end
      }
    end
  end
end
end
