# -*- ruby -*-
# $Id: image.rb,v 1.1 2001/11/24 10:19:20 ttate Exp $

module Fltk
  module_function

  def _remove_ccomment(code)
    c_code = code.dup
    while( cs = c_code.index("/*") )
      if( ce = c_code[cs..-1].index("*/") )
	c_code[cs .. (cs + ce + 1)] = ""
      else
	raise(RuntimeError, "can't find a comment end.")
      end
    end
    return c_code
  end

  def load_pixmap(filename)
    c_code = nil
    File.open(filename){|f|
      c_code = f.read
    }
    c_code = _remove_ccomment(c_code)
    s = c_code.index("{")
    e = c_code.rindex("}")
    r_code = "[" + c_code[s+1 .. e-1] + "]"
    r = eval(r_code)
    if( r[0] =~ /(\d+)\s+(\d+)/ )
      w = $1.to_i
      h = $2.to_i
    else
      w = nil
      h = nil
    end
    return [r, w, h]
  end

  def load_bitmap(filename)
    line1 = line2 = c_code = nil
    File.open(filename){|f|
      line1 = f.gets
      line2 = f.gets
      c_code = f.read
    }
    case line1
    when /width\s+(\d+)/
      w = $1.to_i
    when /height\s+(\d+)/
      h = $1.to_i
    else
      w = nil
      h = nil
    end
    case line2
    when /width\s+(\d+)/
      w = $1.to_i
    when /height\s+(\d+)/
      h = $1.to_i
    else
      w = nil
      h = nil
    end
    c_code = _remove_ccomment(c_code)
    s = c_code.index("{")
    e = c_code.rindex("}")
    r_code = "[" + c_code[s+1 .. e-1] + "]"
    r = eval(r_code)
    return [r, w, h]
  end
end
