module Fltk
	class ListBox < Fltk::Group
		def initialize(w,h)
			super(w,h)
			@buttons = []
			@labels = []
			@browser = Fltk::Browser.new(0,0)
			group_end
			layout
		end
		
		def column_widths(widths = nil)
			result = @browser.column_widths(widths)
			if(widths)
				layout
			end
			return widths
		end
		
		def column_labels(labels)
			@labels = labels
			@buttons.each_index do | i |
			end
			layout
			nil
		end
		
		def add(rowText)
			@browser.add(rowText)
		end
		
		def clear
			@browser.clear
		end
		
		def layout
			group_begin
			@buttons.each do | btn | btn.hide end
			@buttons = []
			realY = y
			realH = h
			if(@labels.size > 0)
				widths = @browser.column_widths
				nextX = 0
				widths.each_index do | i |
					if(i < @labels.size)
						label = @labels[i]
					else
						label = ''
					end
					width = widths[i]
					button = Fltk::Button.new(nextX, 0, width, 20, label)
					button.label(@labels[i])
					@buttons << button
					nextX += width
				end
				realY += 20
				realH -= 20
			end
			@browser.resize(x, realY, w, realH)
			
			group_end
			redraw
			GC.start
		end
	end
end