# -*- ruby -*-

require 'thread'

module FLTK
  FLTK::enable_thread()
  THREAD_MUTEX = Mutex.new
  THREAD_QUEUE = []
  THREAD = Kernel::Thread.new{
    while( true )
      sleep
      FLTK::THREAD_MUTEX.synchronize{
        FLTK::THREAD_QUEUE.each{|obj|
  	  obj.call
        }
        FLTK::THREAD_QUEUE.clear
      }
    end
  }
  THREAD.abort_on_exception = true

  class Thread
    def Thread.start(*args)
      return Thread.new(*args)
    end

    def initialize(val = nil)
      @val    = val
      @thread = nil
      @body   = proc{ @thread = Kernel::Thread.new{ yield(@val) } }
      FLTK::THREAD_MUTEX.synchronize{
        THREAD_QUEUE.push(self)
      }
      THREAD.wakeup
    end

    def call
      @body.call
    end

    def method_missing(sym,*args)
      if( @thread )
	@thread.__send__(sym,*args)
      end
    end
  end
end
