require 'fltk'
require 'fltk/thread'
require 'mkmf'

if( !defined?(FLTK::HelpView) )
  $stderr.print("FLTK should have HelpView widget.\n",
		"Your FLTK seems to be older than 1.1.x.\n")
  exit(1)
end

RUBY = CONFIG["prefix"] + "/bin/" + CONFIG["ruby_install_name"]


Dir.chdir(File.dirname($0))

class DemoHelpView < FLTK::HelpView
  DEMO_FILE = "demo.html"

  def initialize(*args)
    super(*args)
    link{|w,uri|
      case uri
      when /^ruby:(.+)/i
	rbfile = $1
	Thread.new{
	  system("#{RUBY} ./#{rbfile}")
	}
	load(DEMO_FILE)
	nil
      when /^edit:(.+)/i
	rbfile = $1
	Thread.new{
	  system("#{RUBY} ./editor.rb ./#{rbfile}")
	}
	load(DEMO_FILE)
	nil
      when "cmd:quit"
	exit(0)
      else
	uri
      end
    }
    load(DEMO_FILE)
  end
end

FLTK::Window.new(400,300){|win|
  help = DemoHelpView.new(0,0,400,280)
  FLTK::Pack.new(0,280,400,20){|pack|
    pack.packtype = FLTK::HORIZONTAL
    FLTK::Button.new(0,0,50,20,"+1"){ help.textsize += 1 }
    FLTK::Button.new(0,0,50,20,"-1"){ help.textsize -= 1 }
    FLTK::Box.new(0,0,250,20)
    FLTK::Button.new(0,0,50,20,"Quit"){ exit(0) }
  }
  win.resizable(win)
  win.show
}
GC.start
FLTK.run()
