require 'fltk'

if( File.exist?("samples") )
  Dir.chdir("samples")
end

class MyWindow < FLTK::Window
  def initialize(w,h,label)
    super(w,h,label){
      jpg = FLTK::JPEGImage.new("ruby.jpg")
      gif = FLTK::GIFImage.new("ruby.gif")
      bmp = FLTK::BMPImage.new("ruby.bmp")
      xpmimg,xpmw,xpmh = FLTK.load_pixmap("ruby.xpm")
      xpm = FLTK::Pixmap.new(xpmimg)

      border = 10
      lh = 15
      bw = w/2 - (border * 2)
      bh = h/2 - (border * 2) - (lh * 2)
      x1 = border
      y1 = border + lh
      x2 = border + bw
      y2 = border + lh
      x3 = border
      y3 = border + lh + bh + lh
      x4 = border + bw
      y4 = border + lh + bh + lh
      
      jpgbox = FLTK::Box.new(x1,y1,bw,bh, "JPEG")
      jpgbox.box = FLTK::UP_BOX
      gifbox = FLTK::Box.new(x2,y2,bw,bh, "GIF")
      gifbox.box = FLTK::UP_BOX
      bmpbox = FLTK::Box.new(x3,y3,bw,bh, "BMP")
      bmpbox.box = FLTK::UP_BOX
      xpmbox = FLTK::Box.new(x4,y4,bw,bh, "XPM")
      xpmbox.box = FLTK::UP_BOX

      jpg.label(jpgbox)
      gif.label(gifbox)
      bmp.label(bmpbox)
      xpm.label(xpmbox)
    }
  end
end

win = MyWindow.new(400,400, "Images")
win.begin{
  FLTK::Button.new(0,360,50,40,"Quit"){ exit(0) }
}
win.show
FLTK::run()
