require 'fltk'

class RadioButton < FLTK::RoundButton
  def initialize(label)
    super(80,20,label)
    size(80,20)

    button_type(FLTK::RADIO_BUTTON)
    # is equivalent to:
    # button_type = FLTK::RADIO_BUTTON
  end
end

class MyWindow < FLTK::Window
  def initialize
    super(300, 300, 'Radio Buttons'){|win|
      vpack = FLTK::Pack.new(w,h)     # w and h are methods of Widget.
    
      title = FLTK::Box.new(200,20,'Choose a color:')
      #title.align(FLTK::ALIGN_LEFT)

      # The initialize method of each button object can take a callback.
      RadioButton.new('Red'){|win,data| onSetColor(FLTK::RED) }
      RadioButton.new('Green'){|win,data| onSetColor(FLTK::GREEN) }
      RadioButton.new('Blue'){|win,data| onSetColor(FLTK::BLUE) }
      
      @preview = FLTK::Box.new(300,100,'Preview')
      @preview.box(FLTK::FLAT_BOX)

      yield(win)
    }
  end
  
  def onSetColor(color)
    @preview.color(color)
    @preview.redraw()
  end
end

MyWindow.new{|win|
  win.show()
}
Fltk::run()
