require 'fltk'

class MainWindow < FLTK::Window
  def initialize()
    super(300,300,'Lists'){|win|
      FLTK::Pack.new(300,300){
	FLTK::Pack.new(300,200){|pack|
	  pack.pack_type(FLTK::HORIZONTAL)
	  createReadonlyList(['This', 'is', 'read', 'only'])
	  @single = createSingleSelectList(['Single', 'selection', 'here'])
	  @multi = createMultiSelectList(['Multiple', 'selections', 
					   'allowed', 'with',
					   'ctrl-click,', 'shift-click,',
					   'and', 'drag'])
	}
	
	btn = FLTK::Button.new(100,20,'Left Results')
	btn.callback{ FLTK::message("Nothing selected") }
	btn = FLTK::Button.new(100,20,'Middle Results')
	btn.callback{ onShowSingle(@single) }
	btn = FLTK::Button.new(100,20,'Right Results')
	btn.callback{ onShowMulti(@multi) }
      }
      yield(win)
    }
  end
  
  def createReadonlyList(items)
    list = FLTK::Browser.new(100,300)
    items.each{|item| list.add(item) }
    return list
  end
  
  def createSingleSelectList(items)
    list = FLTK::HoldBrowser.new(100,300)
    items.each{|item| list.add(item) }
    return list
  end
  
  def createMultiSelectList(items)
    list = FLTK::MultiBrowser.new(100,300)
    items.each{|item| list.add(item) }
    return list
  end
  
  def onShowSingle(singleList)
    if(singleList.value > 0)
      FLTK::message("Selected row: #{singleList.value}")
    else
      FLTK::message("Nothing selected")
    end
  end

  def onShowMulti(multiList)
    multi = []
    multiList.size.times do | row |
      if(multiList.selected(row+1))
	multi << row+1
      end
    end
    if(multi.size > 0)
      text = "Selected rows: "
      multi.each do |row| text += "#{row} " end
    else
      text = "Nothing selected"
    end
    FLTK::message(text)
  end
end

MainWindow.new{|win|
  win.show()
      }
FLTK::run()
